#!/usr/bin/ruby
# encoding: utf-8
#Diese Software unterliegt der GPL
#Copyright Karlheinz Klingbeil



require 'socket'
require 'optparse'
require 'syslog'

BANNER = 'Portdump 0.1/21.07.2022'
DEFAULT_PORT = 7777 
DEFAULT_HOST = 'localhost'

class Portdump    
  def initialize
    Encoding.default_external = Encoding::UTF_8
    Encoding.default_internal = Encoding::UTF_8

    log BANNER
    @config = {}
    @config[:port] = DEFAULT_PORT
    @config[:host] = DEFAULT_HOST
    OptionParser.new do |opts|
      opts.banner = "Usage: dmc2 [options]"
      opts.on('-p', '--port name', 'input file') { |v| @config[:port] = v }
      opts.on('-h', '--host name', 'input file') { |v| @config[:host] = v }
    end.parse!
    log  "Send Data to #{@config[:host]}:#{@config[:port]}" 
    s = TCPSocket.new @config[:host],@config[:port] 
    log "Socket Open"
    f = STDIN.read()
    log "Data read"
    s.send f,0
    log "Data sent"
    s.close
    log "Portdump closed"
  end

    def getTimeStamp
    date = Time.new
    return date.strftime('%Y-%m-%d-%H-%M-%S')
  end

  def log (str)
    str = "#{getTimeStamp()} :#{str}\n"
    str = str.sub("%","P")
    puts str
    Syslog.open($0, Syslog::LOG_PID|Syslog::LOG_CONS )
    Syslog.log(Syslog::LOG_PID, str )
    Syslog.close
 end


end

p = Portdump.new

